(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question09                 *)

module BI =
struct
  let zero = Big_int.zero_big_int
  let one  = Big_int.unit_big_int

  let add = Big_int.add_big_int

end

let fibo =
  let h = Hashtbl.create 1001 in
  let rec f n =
    try
      Hashtbl.find h n
    with
	Not_found ->
	  let y = BI.add (f (n-1)) (f (n-2)) in
	    Hashtbl.add h n y;
	    y
  in
    Hashtbl.add h 0 BI.zero;
    Hashtbl.add h 1 BI.one;
    f
